#include <stdio.h>
#include "devboard.h"
#include "io.h"

int RBFSize;

void Read()
{
	int port = 0;
	int count = 0;
	int i,j;
	int pp;
	int clk;
	int data;
	int done = 0;
	int mark = 0;
	int temp = 0;
	int size = 0;
	int ram = 0;
	int mask = 0x10; /* NCONFIG = 1 */
	char* pDir;
	char* pData;
	char* pAddr;

	SetPAR(1);

	/* Set Parallel Port as input/output */
	pDir = (char*) (MBASE+PPDDR);
	*pDir = 0x38;/* 1111 1000 */
	
	pData = (char*) (MBASE+PPDAT);
	
	*pData = 0xF8;
	Delay(300);

	/* Getting file size */
	while (!done)
	{
		pp = GetPPReg();
		clk = pp & 0x1;
		data = pp & 0x4;
		data = data >> 0x2;
		
		if(mark)
		{
			if(clk)
			{
				if(count>=32)
				{
					done = 1;
					continue;
				}
				port = port | (data << count);
				count++;
				mark = 0;
			}
		}
		else
		{
			if(!clk)
				mark = 1;
		}
	}

	size = port;

	pp = 0;
	clk = 0;
	data = 0;
	port = 0;
	done = 0;
	mark = 0;
	temp = 0;
	count = 0;
			
	pAddr = (char*) (ADRFBASE);
	
	while(!done)
	{
		pp = GetPPReg();
		clk = pp & 0x1;
		data = pp & 0x4;
		data = data >> 0x2;

		if(mark)
		{
			if(clk)
			{
				if(count>=(8*size)) /* total_bit=total_byte*bit/byte */
				{
					done = 1;
					continue;
				}
				
				count++;				

				port = (data << 5) | mask;
				*pAddr = (char) port;
				pAddr++;
				
				/* Add another vector with DCLK=1 */
				port = port | 0x08;
				*pAddr = (char) port;
				pAddr++;
				
				port = 0;
				mark = 0;
			}
		}
		else
		{
			if(!clk) mark = 1;
		}
	}	

	/* total bits*2 for additional vector with DCLK=1per bit */
	count = count*2;
	
	/* Load Header */
	WriteADRAM(ADRBASE,0xCA);
	/* Load Footer */
	WriteADRAM(ADRFBASE+count,0x53);
	WriteADRAM(ADRFBASE+count+1,0x35);
}

void Download()
{
	int count = 0;
	int data;
	int pass = 1;
	char* pDir 	= (char*) (MBASE+PPDDR);
	
	*pDir = 0xFF;
	
	SetADRAM(ADRBASE,ADREND,0xFF);
	
	for(count=0x3;count>0;count--)
	{
		WritePP(count);
		Delay(100);
	}
	
	*pDir = 0x38;
	
	Read();
}
	
int main()
{
	/***** Functions Call Starts Here *****/
	
	char* argv[2][10];
	char* pDir 	= (char*) (MBASE+PPDDR);
	char* pData = (char*) (MBASE+PPDAT);
	char* pAddr = (char*) (ADRBASE+1);
	int count;
	int temp;
	int j;

	int i;
	
	*argv[0] = "MBLASTER";
	*argv[1] = "ADRAM001";
	
	SetPAR(1);
	
	Download();
	
	/* Set PP pin direction */
	*pDir = 0x38;
	
	count = MBlaster(2,argv);

	fflush(stdout);

	/***** Functions Call Ends Here *****/

	while(1);	// Idle
	
	return 0;
}
