#ifndef MBLASTER_H
#define MBLASTER_H

#define SIG_DCLK			0 /* Passive Serial configuration signals */
#define	SIG_NCONFIG			1
#define SIG_DATA0			2
#define SIG_NSTATUS			3
#define SIG_CONFDONE		4

#define PM_RESET			0 /* Port modes */
#define	PM_USER				1

#define S_CUR				1 /* SEEK_CUR */
#define S_END				2 /* SEEK_END */
#define S_SET				0 /* SEEK_SET */

#define INIT_CYCLE			50		/* #clock cycle after configuration is done and before USER mode */
#define RECONF_COUNT_MAX	5		/* #auto-reconfiguration when error found */
#define	CHECK_EVERY_X_BYTE  10240	/* check NSTATUS pin for error for every X bytes */
									/* DO NOT put '0' */
#define CLOCK_X_CYCLE		0		/* clock another 'x' cycles during initialization (optional) */

/*int	sig_port_maskbit[5][2]	= { { 0,0x1 }, { 0,0x2 }, { 0,0x40 }, { 1,0x10 }, { 1,0x80 } };*/
int	sig_port_maskbit[5][2]	= { { 0,0x8 }, { 0,0x10 }, { 0,0x20 }, { 1,0x80 }, { 1,0x40 } };

/*int	port_mode_data[2][3]	= { {0x42, 0x0, 0x0E}, {0x42, 0x0, 0x0C} };*/
int	port_mode_data[2][3]	= { {0x38, 0x0, 0x0E}, {0x38, 0x0, 0x0C} };

int	port_data[3]			= { 0x38, 0x0, 0x0E };/* Initial value for Port 0, 1 and 2 */

int  MBlaster(int argc,char* argv[]);
void ProcessFileInput(int finputid);
void SetPortMode( int mode );
void Dump2Port( int signal, int data, int clk );
void ProgramByte( int one_byte );
int  CheckSignal( int signal );
void PrintError( int configuration_count );


#endif